#!/bin/sh

fresh=false

for arg in "$@"; do
	[ "$arg" = "--fresh" ] && fresh=true
done

STAGIT=/var/www/git/stagit.out
[ ! -f "$STAGIT" ] && STAGIT=stagit

STAGIT_INDEX=/var/www/git/stagit-index.out
[ ! -f "$STAGIT_INDEX" ] && STAGIT_INDEX=stagit-index

for repo in /srv/git/*.git; do
	repo="$(basename "$repo" | rev | cut -c 5- | rev)"

	[ "$fresh" = true ] \
		&& echo "Deleting HTML for $repo." \
		&& rm -fr "/var/www/git/$repo"
	mkdir -p "/var/www/git/$repo"
	cd "/var/www/git/$repo"

	[ ! -f style.css ]   && ln -s ../style.css ./
	[ ! -f favicon.png ] && ln -s ../favicon.png ./
	[ ! -f logo.png ]    && ln -s ../logo.png ./

	echo "git://git.knutsen.co/$repo" > "/srv/git/$repo.git/url"

	COMMAND="$STAGIT /srv/git/$repo.git"
	echo "$COMMAND"
	$COMMAND
done

echo "Generating index.html with \`$STAGIT_INDEX\`."
"$STAGIT_INDEX" /srv/git/*.git > /var/www/git/index.html
